Package net.sf.saxon.style

## Class XSLGlobalVariable

- java.lang.Object
- - net.sf.saxon.tree.linked.NodeImpl
  - - net.sf.saxon.tree.linked.ParentNodeImpl
    - - net.sf.saxon.tree.linked.ElementImpl
      - - net.sf.saxon.style.StyleElement
        - - net.sf.saxon.style.XSLGlobalVariable

- All Implemented Interfaces:
    `javax.xml.transform.Source`, `javax.xml.transform.SourceLocator`, `GroundedValue`, `Item`, `MutableNodeInfo`, `NamespaceResolver`, `NodeInfo`, `Sequence`, `Location`, `StylesheetComponent`, `SteppingNode<NodeImpl>`, `SiblingCountingNode`, `org.xml.sax.Locator`
  Direct Known Subclasses:
    `XSLGlobalParam`

      public class XSLGlobalVariable
      extends StyleElement
      implements StylesheetComponent

  Handler for xsl:variable elements appearing as a child of xsl:stylesheet.

  The xsl:variable element has mandatory attribute `name` and optional attribute `select` (inter alia)

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from class net.sf.saxon.style.StyleElement

      `StyleElement.OnFailure`

  - ### Field Summary

    Fields
    Modifier and Type | Field | Description
    --- | --- | ---
    `protected GlobalVariable` | `compiledVariable` |
    `protected boolean` | `redundant` |
    `protected SourceBinding` | `sourceBinding` |

    - ### Fields inherited from class net.sf.saxon.style.StyleElement

      `ACTION_COMPILE, ACTION_FIXUP, ACTION_OPTIMIZE, ACTION_PROCESS_ATTRIBUTES, ACTION_TYPECHECK, ACTION_VALIDATE, actionsCompleted, defaultCollationName, defaultMode, defaultXPathNamespace, expandText, extensionNamespaces, reportingCircumstances, staticContext, validationError, version`

    - ### Fields inherited from class net.sf.saxon.tree.linked.NodeImpl

      `NODE_LETTER`

    - ### Fields inherited from interface net.sf.saxon.om.NodeInfo

      `IS_DTD_TYPE, IS_NILLED`

  - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `XSLGlobalVariable()` |

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `void` | `checkCompatibility​(Component component)` | Check the compatibility of this component with another component that it is overriding
    `void` | `compileDeclaration​(Compilation compilation, ComponentDeclaration decl)` | Compile.
    `void` | `fixupReferences()` | Fix up references from XPath expressions.
    `void` | `generateByteCode​(Optimizer opt)` | Generate byte code if appropriate
    `Actor` | `getActor()` | Get the corresponding Procedure object that results from the compilation of this StylesheetProcedure
    `SourceBinding` | `getBindingInformation​(StructuredQName name)` | Ask whether this element contains a binding for a variable with a given name; and if it does, return the source binding information
    `GlobalVariable` | `getCompiledVariable()` |
    `StructuredQName` | `getObjectName()` | Get a name identifying the object of the expression, for example a function name, template name, variable name, key name, element name, etc.
    `protected java.util.EnumSet<SourceBinding.BindingProperty>` | `getPermittedAttributes()` |
    `SequenceType` | `getRequiredType()` | Get the static type of the variable.
    `SlotManager` | `getSlotManager()` | Get the SlotManager associated with this stylesheet construct.
    `SourceBinding` | `getSourceBinding()` | Get the source binding object that holds information about the declared variable.
    `SymbolicName` | `getSymbolicName()` | Get the symbolic name of the component, that is, the combination of the component kind and the qualified name
    `StructuredQName` | `getVariableQName()` |
    `void` | `index​(ComponentDeclaration decl, PrincipalStylesheetModule top)` | Method supplied by declaration elements to add themselves to a stylesheet-level index
    `protected void` | `initializeBinding​(GlobalVariable var)` | Initialize - common code called from the compile() method of all subclasses
    `boolean` | `isAssignable()` | Ask whether the global variable is declared with assignable="yes"
    `boolean` | `isDeclaration()` | Determine whether this node is a declaration.
    `boolean` | `isGlobal()` | Test whether this is a global variable or parameter
    `boolean` | `isInstruction()` | Determine whether this node is an instruction.
    `boolean` | `mayContainSequenceConstructor()` | Determine whether this type of element is allowed to contain a template-body
    `void` | `optimize​(ComponentDeclaration declaration)` | Optimize the stylesheet construct
    `void` | `postValidate()` | Hook to allow additional validation of a parent element immediately after its children have been validated.
    `void` | `prepareAttributes()` | Set the attribute list for the element.
    `void` | `setRedundant​(boolean redundant)` | Mark this global variable as redundant, typically because it is overridden by another global variable of the same name, or because there are no references to it
    `void` | `validate​(ComponentDeclaration decl)` | Check that the stylesheet element is valid.

    - ### Methods inherited from class net.sf.saxon.style.StyleElement

      `allocateLocation, bindLocalVariable, bindVariable, checkEmpty, checkTopLevel, checkUnknownAttribute, compile, compileError, compileError, compileError, compileError, compileError, compileError, compileErrorInAttribute, compileSequenceConstructor, compileSequenceConstructor, compileWarning, compileWarning, compileWarning, generateId, getAttributeValue, getBaseURI, getCompilation, getConfiguration, getContainingPackage, getContainingSlotManager, getDeclaredVisibility, getDefaultCollationName, getDefaultXPathNamespace, getNamespaceResolver, getPackageData, getPrincipalStylesheetModule, getProperties, getSchemaType, getStaticContext, getStaticContext, getTypeAnnotation, getUsedPackage, getVisibility, getWithParamInstructions, getXslOriginal, hasImplicitBinding, invalidAttribute, isExtensionAttributeAllowed, isExtensionNamespace, isPermittedChild, isSchemaAware, issueWarning, issueWarning, isTopLevel, isWithinDeclaredStreamableConstruct, makeAttributeValueTemplate, makeExpression, makeExpressionVisitor, makeQName, makeRetainedStaticContext, makeSequenceType, markTailCalls, mayContainFallback, mayContainParam, processAllAttributes, processBooleanAttribute, processStandardAttributes, processVersionAttribute, reportAbsence, requireSyntaxExtensions, seesAvuncularVariables, setCompilation, setObjectName, setValidationError, substituteFor, typeCheck, typeCheck, validateChildren, validateSubtree, validateValidationAttribute`

    - ### Methods inherited from class net.sf.saxon.tree.linked.ElementImpl

      `addAttribute, addNamespace, addNamespace, attributes, checkNotNamespaceSensitiveElement, copy, delete, fixupInsertedNamespaces, generateId, getAllNamespaces, getAttributeValue, getColumnNumber, getDeclaredNamespaces, getLineNumber, getNodeKind, getNodeName, getRoot, getSchemaType, getSystemId, getURIForPrefix, initialise, isId, isIdref, isInScopeNamespace, isNilled, iteratePrefixes, removeAttribute, removeNamespace, removeTypeAnnotation, rename, replaceStringValue, setAttributeInfo, setAttributes, setLocation, setNamespaceMap, setNilled, setNodeName, setSystemId, setTypeAnnotation`

    - ### Methods inherited from class net.sf.saxon.tree.linked.ParentNodeImpl

      `addChild, children, compact, getFirstChild, getLastChild, getNthChild, getNumberOfChildren, getRawSequenceNumber, getSequenceNumber, getStringValue, getStringValueCS, hasChildNodes, insertChildren, iterateChildren, removeChild, replaceChildrenAt, setChildren, setRawSequenceNumber`

    - ### Methods inherited from class net.sf.saxon.tree.linked.NodeImpl

      `atomize, compareOrder, effectiveBooleanValue, equals, getDisplayName, getFingerprint, getLocalPart, getNamePool, getNextInDocument, getNextSibling, getParent, getPhysicalRoot, getPrefix, getPreviousInDocument, getPreviousSibling, getRawParent, getSiblingPosition, getSuccessorElement, getTreeInfo, getURI, hasFingerprint, head, insertSiblings, isDeleted, iterateAxis, iterateAxis, newBuilder, replace, saveLocation, setRawParent, setSiblingPosition`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

    - ### Methods inherited from interface net.sf.saxon.om.GroundedValue

      `asIterable, concatenate, containsNode, materialize`

    - ### Methods inherited from interface net.sf.saxon.om.Item

      `getLength, itemAt, iterate, reduce, subsequence`

    - ### Methods inherited from interface net.sf.saxon.om.NodeInfo

      `children, equals, getGenre, getPublicId, hashCode, isSameNodeInfo, isStreamed, toShortString`

    - ### Methods inherited from interface net.sf.saxon.om.Sequence

      `makeRepeatable`

    - ### Methods inherited from interface javax.xml.transform.Source

      `isEmpty`

- - ### Field Detail

    - #### sourceBinding

          protected SourceBinding sourceBinding

    - #### compiledVariable

          protected GlobalVariable compiledVariable

    - #### redundant

          protected boolean redundant

  - ### Constructor Detail

    - #### XSLGlobalVariable

          public XSLGlobalVariable()

  - ### Method Detail

    - #### getSourceBinding

          public SourceBinding getSourceBinding()

      Get the source binding object that holds information about the declared variable.
      Returns:
        the source binding

    - #### getVariableQName

          public StructuredQName getVariableQName()

    - #### getObjectName

          public StructuredQName getObjectName()

      Description copied from class: `StyleElement`
      Get a name identifying the object of the expression, for example a function name, template name, variable name, key name, element name, etc. This is used only where the name is known statically. If there is no name, the value will be null.
      Overrides:
        `getObjectName` in class `StyleElement`
      Returns:
        the name of the object declared in this element, if any

    - #### mayContainSequenceConstructor

          public boolean mayContainSequenceConstructor()

      Determine whether this type of element is allowed to contain a template-body
      Overrides:
        `mayContainSequenceConstructor` in class `StyleElement`
      Returns:
        true: yes, it may contain a template-body

    - #### isGlobal

          public boolean isGlobal()

      Test whether this is a global variable or parameter
      Returns:
        true if this is global

    - #### postValidate

          public void postValidate()
                            throws XPathException

      Hook to allow additional validation of a parent element immediately after its children have been validated.
      Overrides:
        `postValidate` in class `StyleElement`
      Throws:
        `XPathException` - if any error is found during post-traversal validation

    - #### getCompiledVariable

          public GlobalVariable getCompiledVariable()

    - #### getPermittedAttributes

          protected java.util.EnumSet<SourceBinding.BindingProperty> getPermittedAttributes()

    - #### getActor

          public Actor getActor()
                         throws XPathException

      Get the corresponding Procedure object that results from the compilation of this StylesheetProcedure
      Specified by:
        `getActor` in interface `StylesheetComponent`
      Returns:
        the compiled ComponentCode
      Throws:
        `XPathException` - if generating the ComponentBody fails

    - #### getSymbolicName

          public SymbolicName getSymbolicName()

      Description copied from interface: `StylesheetComponent`
      Get the symbolic name of the component, that is, the combination of the component kind and the qualified name
      Specified by:
        `getSymbolicName` in interface `StylesheetComponent`
      Returns:
        the component's symbolic name

    - #### checkCompatibility

          public void checkCompatibility​(Component component)

      Description copied from interface: `StylesheetComponent`
      Check the compatibility of this component with another component that it is overriding
      Specified by:
        `checkCompatibility` in interface `StylesheetComponent`
      Parameters:
        `component` - the overridden component

    - #### getBindingInformation

          public SourceBinding getBindingInformation​(StructuredQName name)

      Ask whether this element contains a binding for a variable with a given name; and if it does, return the source binding information
      Overrides:
        `getBindingInformation` in class `StyleElement`
      Parameters:
        `name` - the variable name
      Returns:
        the binding information if this element binds a variable of this name; otherwise null

    - #### prepareAttributes

          public void prepareAttributes()

      Description copied from class: `StyleElement`
      Set the attribute list for the element. This is called to process the attributes (note the distinction from processAttributes in the superclass). Must be supplied in a subclass
      Specified by:
        `prepareAttributes` in class `StyleElement`

    - #### index

          public void index​(ComponentDeclaration decl,
                            PrincipalStylesheetModule top)
                     throws XPathException

      Description copied from class: `StyleElement`
      Method supplied by declaration elements to add themselves to a stylesheet-level index
      Overrides:
        `index` in class `StyleElement`
      Parameters:
        `decl` - the Declaration being indexed. (This corresponds to the StyleElement object except in cases where one module is imported several times with different precedence.)
        `top` - represents the outermost XSLStylesheet or XSLPackage element
      Throws:
        `XPathException` - if any error is encountered

    - #### validate

          public void validate​(ComponentDeclaration decl)
                        throws XPathException

      Description copied from class: `StyleElement`
      Check that the stylesheet element is valid. This is called once for each element, after the entire tree has been built. As well as validation, it can perform first-time initialisation. The default implementation does nothing; it is normally overriden in subclasses.
      Overrides:
        `validate` in class `StyleElement`
      Parameters:
        `decl` - the declaration to be validated
      Throws:
        `XPathException` - if any error is found during validation

    - #### isAssignable

          public boolean isAssignable()

      Ask whether the global variable is declared with assignable="yes"
      Returns:
        true if assignabl="yes" was specified

    - #### isDeclaration

          public boolean isDeclaration()

      Determine whether this node is a declaration.
      Overrides:
        `isDeclaration` in class `StyleElement`
      Returns:
        true - a global variable is a declaration

    - #### isInstruction

          public boolean isInstruction()

      Determine whether this node is an instruction.
      Overrides:
        `isInstruction` in class `StyleElement`
      Returns:
        false - a global variable is not an instruction

    - #### getRequiredType

          public SequenceType getRequiredType()

      Get the static type of the variable. This is the declared type, unless the value is statically known and constant, in which case it is the actual type of the value.
      Returns:
        the declared or inferred static type of the variable

    - #### fixupReferences

          public void fixupReferences()
                               throws XPathException

      Description copied from class: `StyleElement`
      Fix up references from XPath expressions. Overridden for function declarations and variable declarations
      Overrides:
        `fixupReferences` in class `StyleElement`
      Throws:
        `XPathException` - if any references cannot be fixed up.

    - #### compileDeclaration

          public void compileDeclaration​(Compilation compilation,
                                         ComponentDeclaration decl)
                                  throws XPathException

      Compile. This method ensures space is available for local variables declared within this global variable
      Overrides:
        `compileDeclaration` in class `StyleElement`
      Parameters:
        `compilation` - the compilation episode
        `decl` - the containing top-level declaration, for example xsl:function or xsl:template
      Throws:
        `XPathException` - if compilation fails

    - #### initializeBinding

          protected void initializeBinding​(GlobalVariable var)

      Initialize - common code called from the compile() method of all subclasses
      Parameters:
        `var` - the representation of the variable declaration in the compiled executable

    - #### getSlotManager

          public SlotManager getSlotManager()

      Get the SlotManager associated with this stylesheet construct. The SlotManager contains the information needed to manage the local stack frames used by run-time instances of the code.
      Specified by:
        `getSlotManager` in interface `StylesheetComponent`
      Returns:
        the associated SlotManager object

    - #### optimize

          public void optimize​(ComponentDeclaration declaration)
                        throws XPathException

      Optimize the stylesheet construct
      Specified by:
        `optimize` in interface `StylesheetComponent`
      Parameters:
        `declaration` - the declaration of this variable
      Throws:
        `XPathException`

    - #### setRedundant

          public void setRedundant​(boolean redundant)

      Mark this global variable as redundant, typically because it is overridden by another global variable of the same name, or because there are no references to it
      Parameters:
        `redundant` - true if this variable is redundant, otherwise false

    - #### generateByteCode

          public void generateByteCode​(Optimizer opt)

      Generate byte code if appropriate
      Specified by:
        `generateByteCode` in interface `StylesheetComponent`
      Parameters:
        `opt` - the optimizer